// Code generated by protoc-gen-ts_proto. DO NOT EDIT.
// versions:
//   protoc-gen-ts_proto  v1.175.0
//   protoc               v5.27.1
// source: vote.proto

/* eslint-disable */
import { GrpcMethod, GrpcStreamMethod } from "@nestjs/microservices";
import { Observable } from "rxjs";

export const protobufPackage = "voting";

export interface Empty {
}

export interface CreateElectionRequest {
  year: number;
  date: string;
  startTime: string;
  endTime: string;
}

export interface GetElectionRequest {
  id: number;
}

export interface Election {
  id: number;
  year: number;
  date: string;
  startTime: string;
  endTime: string;
}

export interface ElectionList {
  elections: Election[];
}

export interface CreateVoteCountRequest {
  idEleccion: number;
  idLista: number;
  cantVotos: number;
}

export interface GetVoteCountRequest {
  id: number;
}

export interface VoteCount {
  id: number;
  idEleccion: number;
  idLista: number;
  cantVotos: number;
}

export interface VoteCountList {
  voteCounts: VoteCount[];
}

export interface CreateParticipantRequest {
  idEleccion: number;
  idUsuario: number;
  horarioVotacion: string;
}

export interface GetParticipantRequest {
  id: number;
}

export interface Participant {
  id: number;
  idEleccion: number;
  idUsuario: number;
  horarioVotacion: string;
}

export interface ParticipantList {
  participants: Participant[];
}

export const VOTING_PACKAGE_NAME = "voting";

export interface VotingServiceClient {
  createElection(request: CreateElectionRequest): Observable<Election>;

  getElection(request: GetElectionRequest): Observable<Election>;

  listElections(request: Empty): Observable<ElectionList>;

  createVoteCount(request: CreateVoteCountRequest): Observable<VoteCount>;

  getVoteCount(request: GetVoteCountRequest): Observable<VoteCount>;

  listVoteCounts(request: Empty): Observable<VoteCountList>;

  createParticipant(request: CreateParticipantRequest): Observable<Participant>;

  getParticipant(request: GetParticipantRequest): Observable<Participant>;

  listParticipants(request: Empty): Observable<ParticipantList>;
}

export interface VotingServiceController {
  createElection(request: CreateElectionRequest): Promise<Election> | Observable<Election> | Election;

  getElection(request: GetElectionRequest): Promise<Election> | Observable<Election> | Election;

  listElections(request: Empty): Promise<ElectionList> | Observable<ElectionList> | ElectionList;

  createVoteCount(request: CreateVoteCountRequest): Promise<VoteCount> | Observable<VoteCount> | VoteCount;

  getVoteCount(request: GetVoteCountRequest): Promise<VoteCount> | Observable<VoteCount> | VoteCount;

  listVoteCounts(request: Empty): Promise<VoteCountList> | Observable<VoteCountList> | VoteCountList;

  createParticipant(request: CreateParticipantRequest): Promise<Participant> | Observable<Participant> | Participant;

  getParticipant(request: GetParticipantRequest): Promise<Participant> | Observable<Participant> | Participant;

  listParticipants(request: Empty): Promise<ParticipantList> | Observable<ParticipantList> | ParticipantList;
}

export function VotingServiceControllerMethods() {
  return function (constructor: Function) {
    const grpcMethods: string[] = [
      "createElection",
      "getElection",
      "listElections",
      "createVoteCount",
      "getVoteCount",
      "listVoteCounts",
      "createParticipant",
      "getParticipant",
      "listParticipants",
    ];
    for (const method of grpcMethods) {
      const descriptor: any = Reflect.getOwnPropertyDescriptor(constructor.prototype, method);
      GrpcMethod("VotingService", method)(constructor.prototype[method], method, descriptor);
    }
    const grpcStreamMethods: string[] = [];
    for (const method of grpcStreamMethods) {
      const descriptor: any = Reflect.getOwnPropertyDescriptor(constructor.prototype, method);
      GrpcStreamMethod("VotingService", method)(constructor.prototype[method], method, descriptor);
    }
  };
}

export const VOTING_SERVICE_NAME = "VotingService";
